(function (exports) {
'use strict';

var Prebid = function (_akamai$amp$Plugin) {
  babelHelpers.inherits(Prebid, _akamai$amp$Plugin);

  function Prebid(player, config) {
    babelHelpers.classCallCheck(this, Prebid);

    var _this = babelHelpers.possibleConstructorReturn(this, (Prebid.__proto__ || Object.getPrototypeOf(Prebid)).call(this, player, config));

    _this.player = player;
    _this.plugin = pbjs != null ? pbjs : window.pbjs;
    return _this;
  }

  babelHelpers.createClass(Prebid, [{
    key: "onready",
    value: function onready() {
      var _this2 = this;

      if (!this.plugin) return;

      this.player.addTransform(akamai.amp.TransformType.AD_REQUEST, function (ad) {
        return _this2.getAdTag().then(function (data) {
          ad.request.adTagUrl = data;
          return ad;
        }).catch(function (error) {
          return ad;
        });
      });
    }
  }, {
    key: "getAdTag",
    value: function getAdTag() {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        _this3.plugin.que = _this3.plugin.que || [];

        _this3.plugin.que.push(function () {
          var data = _this3.data;
          _this3.plugin.addAdUnits(data.adUnits);

          if (_this3.config.options) {
            _this3.plugin.setConfig(data.options);
          }

          _this3.sendRequest().then(function (bids) {
            for (var key in bids) {
              if (bids.hasOwnProperty(key)) {
                var element = bids[key];
                var cpm = 0;
                if (element.hasOwnProperty("cpm") && element.hasOwnProperty("vastUrl") && element.cpm > cpm) {
                  resolve(element.vastUrl);
                }
              } else {
                reject("");
              }
            }
          }).catch(reject);
        });
      });
    }
  }, {
    key: "sendRequest",
    value: function sendRequest() {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        _this4.plugin.requestBids({
          timeout: Prebid.PREBID_TIMEOUT,
          bidsBackHandler: function bidsBackHandler(data) {
            var adUnits = _this4.data.adUnits;
            var adUnit = Array.isArray(adUnits) ? adUnits.length > 0 ? adUnits[0] : {} : adUnits;
            var code = typeof adUnit.code === "string" ? adUnit.code : Prebid.CODE;
            var bids = data && data[code] ? data[code].bids : null;

            if (!bids) {
              reject("No bids available");
            } else {
              resolve(bids);
            }
          }
        });
      });
    }
  }], [{
    key: "CODE",
    get: function get() {
      return "video";
    }
  }, {
    key: "PREBID_TIMEOUT",
    get: function get() {
      return 1000;
    }
  }]);
  return Prebid;
}(akamai.amp.Plugin);

akamai.amp.AMP.registerPlugin("prebid", akamai.amp.Plugin.createFactory(Prebid));

exports.Prebid = Prebid;

}((this.akamai.amp.prebid = this.akamai.amp.prebid || {})));
//# sourceMappingURL=Prebid.js.map
